<p>OpenCraft just finished moving its infrastructure to Kubernetes. It is a considerable effort and requires the help of every cell. Although we still experiment with Kubernetes, it is visible by now that this effort will be profitable.</p>
<p>The new infrastructure and hosting repositories are located at <a href="https://gitlab.com/opencraft/ops" target="_blank">https://gitlab.com/opencraft/ops</a>.</p>
<h3>Terraform</h3>
<p>We follow the "infrastructure as code" principle, and the new infrastructure was set up in this mentality. All the infrastructure environments OpenCraft has are described in the <a href="https://gitlab.com/opencraft/ops/infrastructure" target="_blank">https://gitlab.com/opencraft/ops/infrastructure</a> repository. This repository contains the terraform scripts for both the legacy and new infrastructure. For more infromation, please check the repo's README.</p>
<h3>DigitalOcean</h3>
<p>OpenCraft decided that the new cloud provider should be DigitalOcean. Why not AWS? The main concerns were its complexity and pricing. We host many instances, which generate significant price differences.</p>
<h3>Access</h3>
<p>As stated in this section's introduction, the new infrastructure requires core member access. The credentials are stored in <a href="https://vault.opencraft.com/ui/vault/secrets" target="_blank">Vault</a>.</p>
<h3>Learning materials</h3>
<p>Although the new infrastructure is simplified as much as possible, for firefighting, it is essential to know the basic Kubernetes concepts. For this, we have created a basic guide on <a  href="https://grove.opencraft.com/user-guides/kubernetes-for-beginners/">Grove and Kubernetes</a>, while a more detailed guide can be found in Kubernetes' own <a href="https://kubernetes.io/docs/tutorials/kubernetes-basics/" target="_blank">Kubernetes Basics</a> tutorial/documentation.</p>
<p>This documentation is huge, do not try to learn every bit of it, that would take long. Focus on the following topics:</p>
<ul>
<li>What namespaces are?</li>
<li>What deployments are?</li>
<li>What services are?</li>
<li>What pods are?</li>
<li>How all these are connected?</li>
<li>How to get a shell in a pod?</li>
</ul>
<p>Since the Kubernetes cluster is managed by DigitalOcean (DOKS -- DigitalOcean (managed) Kubernetes), it is only necessary to know the answer for the above questions. This is the bare minimum to have a less stressful firefighting and to debug most of the issues you may face with.</p>
<h3>Introduction to the new infrastructure</h3>
<p>As stated in the introduction, the new infrastructure is running on Kubernetes. Previously we had no experience running services in Docker or using Kubernetes. Therefore, we recorded a short video to showcase how the new infrastructure is set up and how you can debug/investigate issues that may emerge.</p>
<p>The video is not considering Kubernetes or Terraform concepts, so it is your task to get some knowledge on the basics. The video is available <a  href="https://www.loom.com/share/480a39edafa34ac1ac166a4a94ea4aa1">here</a> (22-25 minutes) if the embedded player below is not working.<p>
<div style="position: relative; padding-bottom: 56.25%; height: 0;margin-top: 2em;"><iframe src="https://www.loom.com/embed/480a39edafa34ac1ac166a4a94ea4aa1" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen style="position: absolute; top: 0; left: 0; width: 100%; height: 100%;"></iframe></div>
